var OURTF = {
    
    id:"ourtf",
    
	replaceTag:function(tag) {
		
    
		var tagsToReplace = {
        '&': '&amp;',
        '<': '&lt;',
        '>': '&gt;' };
    
        return tagsToReplace[tag] || tag;
    },
    
    safe_tags_replace:function(str) {
		 str+="";
        return str.replace(/[&<>]/g, this.replaceTag);
    },

	
	
    exportHiddenField:function(data){
      
        var str="";
        
        str = "<textarea "+
              "name='"+data.id+"' "+
              "id='"+data.id+"' "+
              "style='visibility:hidden;width:0px;height:0px;font-size:0px;'"+
              ">"+this.safe_tags_replace(data.value)+"</textarea>";
           
        return str;

    },
    
    exportRtf:function(args){
      
        var template        = args.template     || null;
        var url             = args.url          || null;
        var fileName        = args.filename     || "file.rtf";
        var message         = args.message      || "Please click the download button to start downloading";
        var buttonTxt       = args.buttonName   || "download";
        var data            = args.data         || null;
        var popup           = true;
		var domMessage      = "";
		var domButton       = "";
		var myWindow;
		var domTemplate 	= "";
		var domForm = "";
		
		if (typeof(args.popup) !== 'undefined'){
			popup=args.popup;
		}
		
        if (url===null)
        {
            
            return;
        }
      
		if (popup === true){
			myWindow = window.open("","ExportWindow","width=400,height=200");
			domMessage = "<p style='font-family:Verdana, sans-serif;padding-top:10px;'>"+message+"<br/>";
			domButton  ="<p style='text-align:center;padding-top:20px;'><input type='submit' value='"+buttonTxt+"' /></p>";
			domForm = "<form action='"+url+"' method='post' target='_blank' onsubmit='window.close();'>";
		}else{
			
			myIframe = document.getElementById("exportIframeId");
			
			if (myIframe == null){
			
				var elm = document.createElement("iframe");
				elm.style.display="none";
				elm.id="exportIframeId";
				document.getElementsByTagName("body")[0].appendChild(elm);
				
				var elmDiv = document.createElement("div");
				elmDiv.style.display="none";
				elmDiv.id="exportDivId";
				document.getElementsByTagName("body")[0].appendChild(elmDiv);
								
			}
			myWindow = document.getElementById("exportDivId");
			domForm = "<form action='"+url+"' method='post' id='exportFormId' target='exportIframeId'>";
		}
	  
       
        
        
        if (template!==null){      
            
            domTemplate = "<input type='hidden' "+
                          "name='rtf_file' "+
                          "id='rtf_file' "+
                          "value='"+template+"' />";
        }
        
        
        var domFileName = "<input type='hidden' "+
                          "name='rtf_output_file_name' "+
                          "id='rtf_output_file_name' "+
                          "value='"+fileName+"' />";
                  
                  
        
        var dataStr="";

        if (data !== null){
            var key;
            for (key in data) {
                if (data.hasOwnProperty(key)){
                  dataStr +=(this.exportHiddenField({"id":key,"value":data[key]}));
                }
            }
        }
        
		
		if (popup === true){
		
			myWindow.document.getElementsByTagName("body")[0].innerHTML = ""+
					domForm +
					domMessage+
					domButton +
					"<p> </p>" +
					domTemplate +
					domFileName+
					dataStr+
					"</form>";
        }else{
		
				
			myWindow.innerHTML = ""+
					domForm +
					"<p> </p>" +
					domTemplate +
					domFileName+
					dataStr+
					"</form>";
					
					
					
					
		    document.getElementById("exportFormId").submit();
		    
			
		}
    }
};

